"""
__heartbeats__
"""
from Table import *
#from types import *
from time import *

class Heartbeats(Table):
  name='heartbeats'
    
  def __init__(self,DASUrl):
    Table.__init__(self,DASUrl,suffix='heartbeats')
    #conversion from general time to delay
    for i in range(len(self.data)):
         time =self.data[i].get('last_updated')
         try:
            #print time
            kk=mktime(localtime())-time
            self.data[i]['last_updated']=kk
            #strftime("%H:%M:%S", gmtime(kk))
            ##I save  the time in seconds from Unix epoch
         except Exception, e:
           self.data[i]['last_updated']="time error"
           pass
  
  
  def buildHeartbeatsCode(self):
      tableTop="""<table border="0" cellspacing="2">
      <tbody><tr><th colspan="%s">Time from component's last heartbeat</th></tr><tr>"""%(len(self.data))
      tableBody=""
      for i in range(len(self.data)):
         lup = self.data[i]['last_updated']
         server = self.data[i]['name']
         plup=strftime("%H:%M:%S", gmtime(lup))
         if (lup>(5*60)): rgb = "red"
         else: rgb= "white"
         tableTop +="""<td style="background-color: rgb(185, 208, 222);"> """+str(server)+"</td>"
         tableBody+="""<td style="background-color: """ +rgb +"""">"""+str(plup)+"</td>"
      return tableTop+ "</tr><tr>"+tableBody +"</tr></tbody></table>"
  
  def getHeartbeats(self):
    return self.data
 
