"""
_MotT0Detail Page_
This page show just 1 table
 
""" 
from WMCore.WebTools.Page import TemplatedPage

from Table import *
from TableContents import *

class MotT0Detail(TemplatedPage):
    title="MotT0 detailed page"
    step=100
    tableCode=""
    
    def __init__(self, kwords,DASUrl,templatedir):
      self.params=kwords
      self.templatedir = templatedir
      contents=[exprJByStatus(self.params,self.step),
                exprMJByStatus(self.params,self.step),
                repkJByStatus(self.params,self.step),
                repkMJByStatus(self.params,self.step),
                recoJByStatus(self.params,self.step),
                recoMJByStatus(self.params,self.step),
                alcaJByStatus(self.params,self.step),
                alcaMJByStatus(self.params,self.step),
                ]
      
      #generate code for tables
      try:
        #print  str(self.params)
        #identify tab
        tableName=self.params['table']
        tableStatus=self.params['status']
        tableRun=self.params['run']
        for cont in contents:
          #print "checking "+ cont.name+"   "+tableName 
          if cont.name==tableName:
             cont.title=cont.title%(tableStatus)
             #print "generating table..."
             table= Table(DASUrl,cont.URL+"?status="+tableStatus+"&run="+str(tableRun)+"&uplimit="+str(cont.upLimit) +'&downlimit='+str(cont.downLimit))
             self.tableCode=table.longTableCode(cont,'detail?status='+tableStatus+"&run="+tableRun+"&")
                    
      except ConnectionException, e:
        pass
      if self.tableCode=="":
        self.tableCode="<B>Conncetion Error or wrong request</B>"
      
      
    def getTemplate(self):
       params={
            "title": self.title,
            "time" : ctime(),
            "tmplPath": self.templatedir,
            "table": self.tableCode
              }
       return self.templatepage('detail', **params )
    
    