"""
_SimpleTable_

This class is a basic view for the data fetched from HTTPfetcher
 
"""

from WMCore.WebTools.Page import TemplatedPage

class SimpleTable(TemplatedPage):
  def __init__(self,config,stat,data,url):
	TemplatedPage.__init__(self, config)
	self.data =data
	self.stat=stat
	self.url=url
	self.__generateTableBody()
	
  def __generateTableBody(self):
  	self.tableBody=""
	if self.stat==0:
	  self.tableBody="<tr>"
	  #info = " TYPE=="+str(type(data)).replace("<","").replace(">","")
	  for i in range(len(self.data)):
	     self.tableBody +="<tr>"
	     for v in self.data[i].values():
	        self.tableBody+="<td>"+str(v)+"<td/>"
	     self.tableBody+= "<tr/>\n"
	else: self.tableBody=str(self.data)


  

  def getHTML(self):
    return  "<table>" + self.tableBody+ "</table>"
  
  def serviceTable(self, sdata):
	  self.tableBody2="<tr>"
	  #info = " TYPE=="+str(type(data)).replace("<","").replace(">","")
	  for i in range(len(sdata)):
	     self.tableBody2 +="<tr>"
	     for v in sdata[i].values():
	        self.tableBody2+="<td>"+str(v)+"<td/>"
	     self.tableBody2+= "<tr/>\n"
	   
  
  def getTemplate(self,title="Example Title"):
	self.heading=""
	return self.templatepage('table',title=title, query=self.url, heading = self.heading, tablebody=self.tableBody,tablebody2=self.tableBody2)